searchNodes=[{"ref":"Artificery.html","title":"Artificery","type":"behaviour","doc":"This module defines the behaviour and public API for Artificery command line applications. Usage To get started, simply use this module, and you can start defining your CLI right away: use Artificery command :hello, &quot;Say hello&quot; do option :name, :string, &quot;The name of the person to greet&quot; end ... def hello(_argv, %{name: name}) do Console.success &quot;Hello \#{name}!&quot; end This module exports a few macros for building up complex CLI applications, so please review the documentation for more information on each, and how to use them."},{"ref":"Artificery.html#argument/2","title":"Artificery.argument/2","type":"macro","doc":"Like option, but rather than a command switch, it defines a positional argument. Beyond the semantics of switches vs positional args, this takes the same configuration as option or defoption Example argument :name, :string"},{"ref":"Artificery.html#argument/3","title":"Artificery.argument/3","type":"macro","doc":"Like argument/2, but takes either help text or a keyword list of flags Example argument :name, :string, &quot;The name to use&quot; argument :name, :string, required: true"},{"ref":"Artificery.html#argument/4","title":"Artificery.argument/4","type":"macro","doc":"Like argument/3, but takes a name, type, help text and keyword list of flags Example argument :name, :string, &quot;The name to use&quot;, required: true"},{"ref":"Artificery.html#command/2","title":"Artificery.command/2","type":"macro","doc":"Defines a new command with the given name and either help text or flags Example command :info, &quot;Displays info about stuff&quot; command :info, hidden: true"},{"ref":"Artificery.html#command/3","title":"Artificery.command/3","type":"macro","doc":"Defines a new command with the given name, flags or help text, and definition, or flags, help text, and no definition Example command :info, &quot;Displays info about stuff&quot; do ... end command :info, [hidden: true] do ... end command :info, [hidden: true], &quot;Displays info about stuff&quot; do ... end"},{"ref":"Artificery.html#command/4","title":"Artificery.command/4","type":"macro","doc":"Defines a new command with the given name, flags, help text, and definition Example command :admin, hidden: true, &quot;Does admin stuff&quot; do ... end"},{"ref":"Artificery.html#defoption/3","title":"Artificery.defoption/3","type":"macro","doc":"Defines an option which can be imported into one or more commands. This is an abstract option definition, i.e. it doesn&#39;t define an option in any scope, it defines options for reuse. This macro takes the option name, type, and either help text or options Valid types are the same as those defined in OptionParser Example defoption :verbose, :boolean, &quot;Turns on verbose output&quot; defoption :verbose, :boolean, hidden: true"},{"ref":"Artificery.html#defoption/4","title":"Artificery.defoption/4","type":"macro","doc":"Like defoption/3, but takes the option name, type, help, and flags Example defoption :verbose, :boolean, &quot;Turns on verbose output&quot;, hidden: true"},{"ref":"Artificery.html#option/1","title":"Artificery.option/1","type":"macro","doc":"Imports an option defined via defoption into the current scope. You may optionally override flags for a given option by passing a keyword list as a second argument. You are not allowed to override the type of the option, but you may override the help text, by passing help: &quot;...&quot; as an override. If you need to override the type, it is better if you use option/3 or option/4 Example defoption :name, :string, &quot;Name of person&quot; command :hello, &quot;Says hello&quot; do # Import with no overrides option :name # Import with overrides option :name, required: true, alias: :n # Import and customize help text option :name, help: &quot;Name of the person to greet&quot; end"},{"ref":"Artificery.html#option/2","title":"Artificery.option/2","type":"macro","doc":"When used in the following form: option :foo, :string This defines a new option, foo, of type string, with no help or flags defined When used like this: option :foo, required: true It imports an option definition (as created via defoption) and provides overrides for the original definition."},{"ref":"Artificery.html#option/3","title":"Artificery.option/3","type":"macro","doc":"Similar to defoption, but defines an option inline. Options defined this way apply either to the global scope, if they aren&#39;t nested within a command macro, or to the scope of the command they are defined in. See defoption for usage examples."},{"ref":"Artificery.html#option/4","title":"Artificery.option/4","type":"macro","doc":""},{"ref":"Artificery.html#c:pre_dispatch/3","title":"Artificery.pre_dispatch/3","type":"callback","doc":""},{"ref":"Artificery.html#t:argv/0","title":"Artificery.argv/0","type":"type","doc":""},{"ref":"Artificery.html#t:options/0","title":"Artificery.options/0","type":"type","doc":""},{"ref":"Artificery.Console.html","title":"Artificery.Console","type":"module","doc":"A minimal logger"},{"ref":"Artificery.Console.html#ask/2","title":"Artificery.Console.ask/2","type":"function","doc":"Ask the user to provide data in response to a question The value returned is dependent on whether a transformation is applied, and whether blank answers are accepted. By default, empty strings will return nil if no alternate default is supplied and either no validator was supplied, or it returned :ok for blank answers. If you supply a default, instead of nil, the default will be returned. Again this only applies if a blank answer is considered valid. You may validate answers by supplying a function (bound or captured) via the validator: fun option. This function will receive the raw input string supplied by the user, and should return :ok if the answer is valid, or {:error, validation_error}, where validation_error is a string which will be displayed to the user before asking them to answer the question again. You may apply a transformation to answers, so that rather than getting a string back, you get the value in a state useful for your application. You may provide a transform via the transform: fun option, and this will receive the raw input string the user provided after the validator has validated the input, if one was supplied, and if the user input was non-nil. Supply default values with the default: term option"},{"ref":"Artificery.Console.html#configure/1","title":"Artificery.Console.configure/1","type":"function","doc":"Updates the logger configuration with the given options."},{"ref":"Artificery.Console.html#debug/2","title":"Artificery.Console.debug/2","type":"function","doc":"Prints a debug message, only visible when verbose mode is on"},{"ref":"Artificery.Console.html#error/2","title":"Artificery.Console.error/2","type":"function","doc":"Prints an error message, and then halts the process"},{"ref":"Artificery.Console.html#halt/1","title":"Artificery.Console.halt/1","type":"function","doc":"Terminates the process with the given status code"},{"ref":"Artificery.Console.html#info/2","title":"Artificery.Console.info/2","type":"function","doc":"Prints an info message"},{"ref":"Artificery.Console.html#notice/2","title":"Artificery.Console.notice/2","type":"function","doc":"Prints a notice"},{"ref":"Artificery.Console.html#spinner/3","title":"Artificery.Console.spinner/3","type":"macro","doc":"Provides a spinner while some long-running work is being done. Options spinner: one of the spinners defined in Artificery.Console.Spinner Example Console.spinner &quot;Loading...&quot;, [spinner: :simple_dots] do :timer.sleep(5_000) end"},{"ref":"Artificery.Console.html#success/2","title":"Artificery.Console.success/2","type":"function","doc":"Prints a success message"},{"ref":"Artificery.Console.html#update_spinner/1","title":"Artificery.Console.update_spinner/1","type":"function","doc":"Updates a running spinner with the provided status text"},{"ref":"Artificery.Console.html#warn/2","title":"Artificery.Console.warn/2","type":"function","doc":"Prints a warning message"},{"ref":"Artificery.Console.html#write/1","title":"Artificery.Console.write/1","type":"function","doc":"Write text or iodata to standard output. You may optionally pass a list of styles to apply to the output, as well as the device to write to (:standard_error, or :stdio)"},{"ref":"Artificery.Console.html#write/2","title":"Artificery.Console.write/2","type":"function","doc":""},{"ref":"Artificery.Console.html#write/3","title":"Artificery.Console.write/3","type":"function","doc":""},{"ref":"Artificery.Console.html#yes?/1","title":"Artificery.Console.yes?/1","type":"function","doc":"Ask the user a question which requires a yes/no answer, returns a boolean"},{"ref":"Artificery.Console.Table.html","title":"Artificery.Console.Table","type":"module","doc":"A printer for tabular data"},{"ref":"Artificery.Console.Table.html#format/4","title":"Artificery.Console.Table.format/4","type":"function","doc":"Given a title, header, and rows, formats the data as a table. Takes an optional keyword list of options: padding: integer sets the padding around columns This function formats the data as iodata, it is up to the caller to print it"},{"ref":"Artificery.Console.Table.html#print/4","title":"Artificery.Console.Table.print/4","type":"function","doc":"Given a title, header, and rows, prints the data as a table. Takes the same options as format/4."},{"ref":"Artificery.Entry.html","title":"Artificery.Entry","type":"module","doc":"This module defines the entrypoint for Artificery command line applications, which handles argument parsing, dispatch, and help generation."}]